<script lang="ts">
  import TaskCard from '@components/TaskBoard/TaskCard.svelte';
  import { Gql } from '@db';
  import { Input } from '@sveltestrap/sveltestrap';
  import { keycloak } from '@stores';
  import AssignTaskModal from './AssignTaskModal.svelte';
  import { type KanbanTask, taskOptions } from '@models/Kanban';
  import { getTeammates } from '@models/Team';
  import TaskDetailModal from './TaskDetailModal.svelte';
  import { EventRole } from "@auth/models";
  import { KanbanTasksByTeamStore } from "$houdini";

  export let teamId: string | undefined;

  const tasksStore = new KanbanTasksByTeamStore()
  $: tasksStore.listen(
    { teamId },
    {
      metadata: { role: $keycloak.getFirstRole([EventRole.Staff, EventRole.Participant]) }
    }
  )
  $: tasks = $tasksStore.data?.scoreboard_kanban || [];

  // let tasks: KanbanTask[] = [];
  $: displayedTasks = getDisplayedTasks(tasks, viewSelfAssigned).sort(
    (t1, t2) => Date.parse(t2.created_at) - Date.parse(t1.created_at),
  );
  let assignTask: (task_id?: string | undefined) => void;
  let showModal: (task_id?: string | undefined) => void;
  let viewSelfAssigned = false;

  function getDisplayedTasks(tasks: KanbanTask[], viewSelfAssigned: boolean) {
    if (viewSelfAssigned) {
      return tasks.filter((t) => t.assignee_id === $keycloak.tokenParsed?.sub);
    }
    return tasks;
  }

  export async function drop(event: DragEvent, droppedStatus: string) {
    event.preventDefault();
    console.log('event', event, event.offsetY, event.offsetX);
    const taskId = event?.dataTransfer?.getData('text/plain');
    if (!taskId) return;
    // Do a local update
    let task = tasks.find((t) => t.id == taskId);
    if (task) {
      task.status = droppedStatus;
      // re-assign tasks to force a re-render now
      tasks = [...tasks];
    }
    await Gql.query(
      `mutation UpdateKanbanStatus {
      update_scoreboard_kanban_by_pk(
        pk_columns: {id: ${JSON.stringify(taskId)}},
        _set: {status: ${JSON.stringify(droppedStatus)}}
      ) {
        id, status
      }
    }`,
    );
  }
</script>

{#if teamId}
  {#await getTeammates(teamId) then teammates}
    <AssignTaskModal bind:show={assignTask} {teammates} {tasks} />
    <TaskDetailModal bind:show={showModal} {tasks} {teammates} assignTask={(id) => assignTask(id)} />

    <div>
      <Input label="Assigned to me" class="clickable" type="switch" bind:checked={viewSelfAssigned} />
    </div>

    <div class="row gx-1 h-100 pb-4">
      {#each taskOptions as option}
        <div
          class="task-column col mx-2 rounded bg-opacity-25 h-100"
          style="background-color: rgba(0, 0, 0, .50);"
          on:drop={(event) => drop(event, option.status)}
        >
          <h3 class="rounded-top text-center pt-2 bg-{option.headerColor}" style="height: 45px;">
            {option.status}
          </h3>
          <div class="overflow-auto" style="height: calc(100% - 55px);">
            {#each displayedTasks as task (task.id)}
              {#if option.status === task.status}
                <TaskCard {assignTask} {showModal} {task} {teammates} />
              {/if}
            {/each}
          </div>
        </div>
      {/each}
    </div>
  {/await}
{/if}
